//+------------------------------------------------------------------+
//|                                                    NETSample.mq4 |
//|                                                       Lantitudia |
//|                                             Lantitudia@yandex.ru |
//+------------------------------------------------------------------+
#property copyright "Lantitudia"
#property link "Lantitudia@yandex.ru"

#import "MQLGate.dll"
   int MQLGate_iInit(int &aiErrorCode[1]);
   void MQLGate_vDeInit(int tmHandle, int &aiErrorCode[1]);
   int MQLGate_iGetIntValue(int tmHandle, int &aiErrorCode[1]);
   string MQLGate_sGetStringValue(string &asBuffer[], int iBufferItemCount,
      int tmHandle, int &aiErrorCode[1]);
   void MQLGate_vStart(string a_symbol, double a_ask, double a_bid, int tmHandle, int &aiErrorCode[1]);
#import

//   NET 

static int NETGate_aiErrorCode[1] = { 0 };
static int NETGate_iTMHandle = 0;
static string NETGate_sBuffer[1] = { "" };

bool NETGate_bIsError()
{
   return (NETGate_aiErrorCode[0]!=0);
}

int NETGate_iGetLastError()
{
   return (NETGate_aiErrorCode[0]);
}

int NETGate_iInit()
{
   NETGate_iTMHandle = MQLGate_iInit(NETGate_aiErrorCode);
   if (NETGate_bIsError())
   {
      Print("  MQLGate_iInit! : "+NETGate_iGetLastError());
      return (-1);
   }
   else
   {
      Print(" !  : "+NETGate_iTMHandle);
      //       
      NETGate_sBuffer[0] = "0123456789";
      for (int i=0; i<10; i++)
      {
         NETGate_sBuffer[0] = StringConcatenate(NETGate_sBuffer[0], NETGate_sBuffer[0]);
      }
      return (1);
   }
}

int NETGate_iDeInit()
{
   if (NETGate_iTMHandle>0)
   {
      MQLGate_vDeInit(NETGate_iTMHandle, NETGate_aiErrorCode);
      NETGate_iTMHandle = -1;
      if (NETGate_bIsError())
      {
         Print("  MQLGate_vDeInit! : "+NETGate_iGetLastError());
         return (-1);
      }
      else
      {
         Print(" !");
      }
   }
}

void NETGate_vStart()
{
   if (NETGate_iTMHandle>0)
   {
      MQLGate_vStart(Symbol(), Ask, Bid, NETGate_iTMHandle, NETGate_aiErrorCode);
      if (NETGate_bIsError())
      {
         Print("  NETGate_vStart! : "+NETGate_iGetLastError());
      }
   }
}

string NETGate_sGetStringValue()
{
   string res = MQLGate_sGetStringValue(NETGate_sBuffer, ArrayRange(NETGate_sBuffer, 0), NETGate_iTMHandle, NETGate_aiErrorCode);
   if (NETGate_bIsError())
   {
      Print("  NETGate_sGetStringValue! : "+NETGate_iGetLastError());
      return ("");
   }
   else
   {
      return (res);
   }
}

int NETGate_iGetIntValue()
{
   int res = MQLGate_iGetIntValue(NETGate_iTMHandle, NETGate_aiErrorCode);
   if (NETGate_bIsError())
   {
      Print("  NETGate_sGetStringValue! : "+NETGate_iGetLastError());
      return (-1);
   }
   else
   {
      return (res);
   }
}

// ===   ====

int init()
{
   int initRes = NETGate_iInit();
   if (initRes<0)
   {
      return (initRes);
   }
   else
   {
      int iRes = NETGate_iGetIntValue();
      if (!NETGate_bIsError())
      {
         Alert("   MQLGate_iGetIntValue: "+iRes);
      }
      string sRes = NETGate_sGetStringValue();
      if (!NETGate_bIsError())
      {
         Alert("   NETGate_sGetStringValue: "+sRes);
      }
      return (0);
   }
}

int deinit()
{
   return (NETGate_iDeInit());
}

int start()
{
   //      0.005 
   NETGate_vStart();
   return (0);
}

