#include "stdafx.h"
#include "MQLGate.h"

using namespace System;
using namespace System::Runtime::InteropServices;

using namespace TradingMachineSample;

//    MQL
struct MQLString
{
	int len; //      .     .
		//            MQL .
	char *string; //  .
};

void ExceptionProcessing(int *a_errorCode)
{
	//   
	*a_errorCode = -1;
}

void CopyNETStringToMQLBuffer(MQLString *a_buffer, int a_bufferItemCount, String ^a_source)
{
	if (a_bufferItemCount<1)
	{
		throw;
	}
	IntPtr ipRes = Marshal::StringToHGlobalAnsi(a_source);
	char *cpRes = (char*)ipRes.ToPointer();
	if (int(strlen(cpRes))>=a_buffer[0].len)
	{
		throw;
	}
	strcpy_s(a_buffer[0].string, a_buffer[0].len, cpRes);
	Marshal::FreeHGlobal(ipRes);
}

// === API  MQL  ===

MQLGATE_API int __stdcall MQLGate_iInit(int *a_errorCode)
{
	try
	{
		return TMSampleManager::Init(*a_errorCode);
	}
	catch (...)
	{
		ExceptionProcessing(a_errorCode);
		return 0;
	}
}

MQLGATE_API void __stdcall MQLGate_vDeInit(int a_index, int *a_errorCode)
{
	try
	{
		TMSampleManager::DeInit(a_index, *a_errorCode);
	}
	catch (...)
	{
		ExceptionProcessing(a_errorCode);
	}
}

MQLGATE_API void __stdcall MQLGate_vStart(char *a_symbol, double a_ask, double a_bid,
										 int a_index, int *a_errorCode)
{
	try
	{
		String^ symbol = Marshal::PtrToStringAnsi(IntPtr(a_symbol));
		TMSampleManager::Start(symbol, a_ask, a_bid, a_index, *a_errorCode);
	}
	catch (...)
	{
		ExceptionProcessing(a_errorCode);
	}
}

MQLGATE_API int __stdcall MQLGate_iGetIntValue(int a_index, int *a_errorCode)
{
	try
	{
		return TMSampleManager::GetIntValue(a_index, *a_errorCode);
	}
	catch (...)
	{
		ExceptionProcessing(a_errorCode);
		return 0;
	}
}

MQLGATE_API char* __stdcall MQLGate_sGetStringValue(MQLString *a_buffer, int a_bufferItemCount,
													int a_index, int *a_errorCode)
{
	try
	{
		String^ hRes = TMSampleManager::GetStringValue(a_index, *a_errorCode);
		CopyNETStringToMQLBuffer(a_buffer, a_bufferItemCount, hRes);
		return a_buffer[0].string;
	}
	catch (...)
	{
		ExceptionProcessing(a_errorCode);
		return "";
	}
}
