﻿using System;
using System.Collections.Generic;
using System.Text;

namespace TradingMachineSample
{
    public class ObjectManager<T>
    {
        protected SortedDictionary<int, T> s_objects = new SortedDictionary<int, T>();
        protected int s_objectIndex = 0;

        public int RegisterObject(T a_obj)
        {
            lock (s_objects)
            {
                s_objectIndex++;
                s_objects.Add(s_objectIndex, a_obj);
                return s_objectIndex;
            }
        }

        public void UnregisterObject(int a_index)
        {
            s_objects.Remove(a_index);
        }

        public T this[int a_index]
        {
            get
            {
                return s_objects[a_index];
            }
        }
    }
}
